/****************************
 * DreamShell ##version##   *
 * lua.h                    *
 * DreamShell LUA           *
 * Created by SWAT          *
 ****************************/     

#ifndef _DS_LUA_H
#define _DS_LUA_H


#ifdef DS_ARCH_DC

#include <lua/lua.h>
#include "tolua.h"

#elif DS_ARCH_PSP

#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>


#else

#include "lua.h"
#include "lauxlib.h"
#include "lualib.h"


#endif

#ifndef DS_ARCH_DC

#define lua_dofile luaL_loadfile
#define lua_dostring luaL_loadstring
#define lua_dobuffer luaL_loadbuffer

#define luaL_check_lstr 	luaL_checklstring
#define luaL_opt_lstr 	luaL_optlstring 
#define luaL_check_number 	luaL_checknumber 
#define luaL_opt_number	luaL_optnumber
#define luaL_arg_check	luaL_argcheck
#define luaL_check_string	luaL_checkstring
#define luaL_opt_string	luaL_optstring
#define luaL_check_int	luaL_checkint
#define luaL_check_long	luaL_checklong
#define luaL_opt_int	luaL_optint
#define luaL_opt_long	luaL_optlong

void luaB_set_fputs(void (*f)(const char *));

#endif



#define LUA_DO_FILE 0
#define LUA_DO_STRING 1

int lua_packlibopen(lua_State *L); 



int InitLua(); 
void ShutdownLua(); 
lua_State *GetLuaState(); 
void SetLuaState(lua_State *L);

lua_State *NewLuaThread();

//void register_getargs(char *argv[], lua_State *lu); 
void LuaOpenlibs(lua_State *L); 
void RegisterLuaFunctions(lua_State *L);
//void LuaAssign(char *arg, lua_State *lu); 
void LuaPushArgs(lua_State *L, char *argv[]); 
void LuaAddArgs(lua_State *L, char *argv[]);
//int LuaDo(int (*f)(lua_State *L, const char *), const char *name, lua_State *lu); 
int LuaDo(int type, const char *name, lua_State *lu);
int RunLuaScript(char *fn, char *argv[]);
//int tolua_SDL_open (lua_State*);
//int tolua_KOS_open (lua_State*);
//int tolua_DS_open (lua_State*);

#endif
