/****************************
 * DreamShell ##version##   *
 * module.h                 *
 * DreamShell modules       *
 * Created by SWAT          *
 ****************************/ 


#ifndef _DS_MODULE_H
#define _DS_MODULE_H


#include "ds.h"



typedef struct Module {

#ifdef DS_ARCH_DC 
    klibrary_t *lib;
#elif DS_ARCH_PSP
    SceUID lib;
#else
    void *lib;
#endif
	const char *fn;
    const char *name;
    int refcnt;
    int id;

} Module_t;




int InitModules();
void ShutdownModules();

Module_t *OpenModule(const char *fn);

int CloseModule(Module_t *m);

Item_list_t *GetModuleList();

Module_t *GetModuleById(int id);
Module_t *GetModuleByFileName(const char *fn);
Module_t *GetModuleByName(const char *name);


#ifdef DS_ARCH_DC 
uint32 GetFuncAddr(char *func);
#endif


#endif
